__kernel void calc( __global float *x, __global float *result, uint M, uint N )
{  
  uint i,j, id = get_global_id(0), sz = get_global_size(0);
  for (int i = id; i<N; i += sz)
  {
    float loc_x = x[i];
    float sum=.0f;
    for (j=0; j<M; j++)
      sum += 1.0f/(loc_x*loc_x+j);
    result[i] = sum;
  }
}


__kernel void calc4( __global float4 *x, __global float4 *result, uint M, uint N )
{  
  uint i,j, id = get_global_id(0), sz = get_global_size(0);
  i = get_global_id(0);
  for (int i = id; i<N/4; i += sz)
  {
    float4 loc_x = x[i];
    float4 sum = .0f;
    for (j=0; j<M; j++)
      sum += 1.0f/(loc_x*loc_x+j);
    result[i] = sum;
  }
}

